/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.datei.boundary;

import de.ivu.elect.business.datei.entity.DateiImport;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class DateiImportDAO extends AbstractDateiImportDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(DateiImport dateiImport){
    getEntityManager().persist(dateiImport);
  }

  public void remove(DateiImport dateiImport){
    getEntityManager().remove(dateiImport);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                        
        /**
        * Name: DateiImportArtAndWahlOrderBeiErstellungszeitpunktDescNoFlush<br>
        * Beschreibung: Wird für die Suche beim Import von Dateien genutzt.<br>
        * EJBQL: SELECT OBJECT(o) FROM DateiImport o WHERE o.dateiArt=?1 AND o.datei.wahl = ?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<DateiImport> findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiImportArt dateiArt,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiImport.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc" ,  dateiArt ,  wahl  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  ));
        }
        return (java.util.List<DateiImport>) cached;
        }
            return super.findByDateiImportArtAndWahlOrderBeiErstellungszeitpunktDesc( dateiArt ,  wahl  );
            }
                                                
        /**
        * Name: DateiImportArtOrderBeiErstellungszeitpunktDescNoFlush<br>
        * Beschreibung: Wird für die Suche beim Import von Dateien genutzt.<br>
        * EJBQL: SELECT OBJECT(o) FROM DateiImport o WHERE o.datei.mandant=?1 AND o.dateiArt=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<DateiImport> findByDateiImportArtOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiImportArt dateiArt) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("DateiImport.findByDateiImportArtOrderBeiErstellungszeitpunktDesc" ,  mandant ,  dateiArt  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByDateiImportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  ));
        }
        return (java.util.List<DateiImport>) cached;
        }
            return super.findByDateiImportArtOrderBeiErstellungszeitpunktDesc( mandant ,  dateiArt  );
            }
                        
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}